'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _hl = require('./hl7-2.4');

var _hl2 = _interopRequireDefault(_hl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Decoder = function () {
  function Decoder(message, config) {
    _classCallCheck(this, Decoder);

    this._message = message;
    this._config = config;
    this._decoder = this._setDynamicDecoder(config.format);
  }

  /**
   * @description Call process method from dynamic class
   * @return {*}
   */


  _createClass(Decoder, [{
    key: 'decode',
    value: function decode() {
      return this._decoder.process();
    }

    /**
     * @description Instantiate dynamically right class
     * @param format
     * @return {*}
     * @private
     */

  }, {
    key: '_setDynamicDecoder',
    value: function _setDynamicDecoder(format) {
      var obj = format === 'hl7-2.4' ? new _hl2.default(this._message, this._config) : null;
      if (!obj) throw new Error('Unknow format: ' + format);
      return obj;
    }
  }]);

  return Decoder;
}();

exports.default = Decoder;
//# sourceMappingURL=index.js.map
